local e=require"luci.model.uci".cursor()
local m=require"nixio".bit
local a=require"luci.ip"
function find_ll()
local e,e
for t,e in ipairs(a.routes({family=6,dest="fe80::/64"}))do
if e.dest:higher("fe80:0:0:0:ff:fe00:0:0")then
return(e.dest-"fe80::")
end
end
return a.IPv6("::")
end
local s=e:get("siit","ipv6","ula_prefix")or"fd00::"
local t=e:get("siit","ipv6","ula_global")or"00ca:ffee:babe::"
local r=e:get("siit","ipv6","ula_subnet")or"0000:0000:0000:4223::"
local h=e:get("siit","ipv6","siit_prefix")or"::ffff:0000:0000"
local i=e:get("siit","ipv4","pool")or"172.16.0.0/12"
local o=e:get("siit","ipv4","netsize")or"24"
local n=a.IPv4(i)
local i=a.IPv6("::/64")
for t,e in ipairs({s,t,r})do
i=i:add(a.IPv6(e))
end
i=i:add(find_ll())
f=SimpleForm("siitwizard","SIIT-Wizard",
"This wizard helps to set up SIIT (IPv4-over-IPv6) translation according to RFC2765.")
f:field(DummyValue,"info_ula","Mesh ULA address").value=i:string()
f:field(DummyValue,"ipv4_pool","IPv4 allocation pool").value=
"%s (%i hosts)"%{n:string(),2^(32-n:prefix())-2}
f:field(DummyValue,"ipv4_size","IPv4 LAN network prefix").value=
"%i bit (%i hosts)"%{o,2^(32-o)-2}
mode=f:field(ListValue,"mode","Operation mode")
mode:value("client","Client")
mode:value("gateway","Gateway")
dev=f:field(ListValue,"device","Wireless device")
e:foreach("wireless","wifi-device",
function(e)
dev:value(e[".name"])
end)
lanip=f:field(Value,"ipaddr","LAN IPv4 subnet")
function lanip.formvalue(e,i)
local s=e.map:formvalue(e:cbid(i))
local t=a.IPv4("%s/%i"%{s,o})
if t then
if n:contains(t)then
if not t:minhost():equal(t:host())then
e.error={[i]=true}
f.errmessage="IPv4 address is not the first host of "..
"subnet, expected "..t:minhost():string()
end
else
e.error={[i]=true}
f.errmessage="IPv4 address is not within the allocation pool"
end
else
e.error={[i]=true}
f.errmessage="Invalid IPv4 address given"
end
return s
end
dns=f:field(Value,"dns","DNS server for LAN clients")
dns.value="141.1.1.1"
function f.handle(t,e,t)
if e==FORM_VALID then
luci.http.redirect(luci.dispatcher.build_url("admin","uci","changes"))
return false
end
return true
end
function mode.write(s,t,c)
local o=a.IPv4(
(lanip:formvalue(t)or"172.16.0.1").."/"..o
)
if not o then return end
local s=dev:formvalue(t)
local u=dns:formvalue(t)or"141.1.1.1"
local s="siit-"..o:host():string():gsub("%.","-")
local t=dev:formvalue(t)
local d=e:get("siit","wifi","essid")or"6mesh.freifunk.net"
local r=e:get("siit","wifi","bssid")or"02:ca:ff:ee:ba:be"
local l=e:get("siit","wifi","channel")or"1"
e:delete_all("wireless","wifi-iface",
function(e)return e.device==t end)
e:delete_all("network","interface",
function(e)return e['.name']==t end)
e:tset("wireless",t,{
disabled=0,
channel=l,
})
e:section("wireless","wifi-iface",nil,{
encryption="none",
mode="adhoc",
txpower=10,
sw_merge=1,
network=t,
device=t,
ssid=d,
bssid=r,
})
if c=="gateway"then
e:set("network","wan","mtu",1240)
e:tset("network","lan",{
mtu=1240,
ipaddr=o:host():string(),
netmask=o:mask():string(),
proto="static"
})
siit_route=a.IPv6(h.."/96")
e:delete_all("network","route",
function(e)return e.interface=="siit0"end)
e:section("network","route",nil,{
interface="siit0",
target=n:network():string(),
netmask=n:mask():string()
})
else
e:tset("network","lan",{
mtu=1240,
ipaddr=o:host():string(),
netmask=o:mask():string()
})
siit_route=a.IPv6(
h.."/"..(96+o:prefix())
):add(o[2])
e:delete_all("network","route",
function(e)return e.interface=="siit0"end)
e:section("network","route",nil,{
interface="siit0",
target="0.0.0.0",
netmask="0.0.0.0"
})
end
e:delete_all("firewall","zone",
function(e)return(
e['.name']=="siit0"or e.name=="siit0"or
e.network=="siit0"or e['.name']==t or
e.name==t or e.network==t
)end)
e:delete_all("firewall","forwarding",
function(e)return(
e.src==t and e.dest=="siit0"or
e.dest==t and e.src=="siit0"or
e.src=="lan"and e.dest=="siit0"or
e.dest=="lan"and e.src=="siit0"
)end)
e:section("firewall","zone","siit0",{
name="siit0",
network="siit0",
input="ACCEPT",
output="ACCEPT",
forward="ACCEPT"
})
e:section("firewall","zone",t,{
name=t,
network=t,
input="ACCEPT",
output="ACCEPT",
forward="ACCEPT"
})
e:section("firewall","forwarding",nil,{
src=t,
dest="siit0"
})
e:section("firewall","forwarding",nil,{
src="siit0",
dest=t
})
e:section("firewall","forwarding",nil,{
src="lan",
dest="siit0"
})
e:section("firewall","forwarding",nil,{
src="siit0",
dest="lan"
})
e:delete_all("firewall","include",
function(e)return e.path=="/etc/firewall.user"end)
e:section("firewall","include",nil,{
path="/etc/firewall.user"
})
e:delete_all("network","interface",
function(e)return(e.ifname=="siit0")end)
e:section("network","interface","siit0",{
ifname="siit0",
proto="none"
})
e:delete_all("network","route6",
function(e)return siit_route:contains(a.IPv6(e.target))end)
e:section("network","route6",nil,{
interface="siit0",
target=siit_route:string()
})
e:section("network","interface",t,{
proto="static",
mtu=1400,
ip6addr=i:string()
})
e:delete_all("olsrd","Interface",
function(e)return e.interface==t end)
e:foreach("olsrd","olsrd",
function(t)e:set("olsrd",t['.name'],"IpVersion",6)end)
e:section("olsrd","Interface",nil,{
ignore=0,
interface=t,
Ip6AddrType="unique-local"
})
e:delete_all("olsrd","Hna6",
function(e)return true end)
e:section("olsrd","Hna6",nil,{
netaddr=siit_route:host():string(),
prefix=siit_route:prefix()
})
e:foreach("olsrd","LoadPlugin",
function(t)
if t.library=="olsrd_txtinfo"then
e:set("olsrd",t['.name'],"accept","::1")
elseif t.library=="olsrd_nameservice"then
e:set("olsrd",t['.name'],"name",s)
end
end)
e:tset("dhcp","lan",{
dhcp_option="6,"..u,
start=m.band(o:minhost():add(1)[2][2],255),
limit=(2^(32-o:prefix()))-3
})
e:foreach("system","system",
function(t)
e:set("system",t['.name'],"hostname",s)
end)
e:save("wireless")
e:save("firewall")
e:save("network")
e:save("system")
e:save("olsrd")
e:save("dhcp")
end
return f
